--Inspired by Puman's 'First Aid Station' mod. Well, 'inspired' - basically it`s his medkit, rewritten to KILL instead of HEAL. Mwa-ha-ha-ha-ha.


local SearchDistance = 2.5

-- damage per time:
local DamageFactor = 0.5


local timer = 0
local nextTimeout = 0.1
local numTargets = 0
local targets = {}
local registerTiming = {}
local arcEffects = {}
local arcEffects2 = {}

function Create()
    Set("NextUpdate", Game.Time() + 0.1)
    Set("LastUpdate", Game.Time())
end

function Update(timePassed)
    timer = timer + timePassed;
    if timer > nextTimeout then
        nextTimeout = IntervalUpdate(timer)
        timer = 0
    end   
end   

function IntervalUpdate(timePassed)
    FindTargets(timePassed)
    DamageF(timePassed * DamageFactor)
    if numTargets > 0 then
        return 0.1
    end
        
    return 1.0  
end

function FindTargets()
    local objectTypes = { "Prisoner" }
    for i,objectType in ipairs( objectTypes ) do 
        FindTargetType(objectType)
    end
end

function FindTargetType(typeName)
    local objects = Object.GetNearbyObjects(typeName, SearchDistance)
    for id, dist in pairs(objects) do
        local damage = tonumber(Object.GetProperty(id, "Damage")) or 0
        if damage < 1 then
            RegisterTarget(id, damage)           
        end
    end
end

function RegisterTarget(id, damage)
    targets[id] = damage
    registerTiming[id] = Game.Time()
    numTargets = numTargets + 1;
end

function UnregisterTarget(id)
    targets[id] = nil            
    registerTiming[id] = nil
    numTargets = numTargets - 1
	
    local effect = arcEffects[id];
    if effect ~= nil then
        Object.Delete(effect)
        arcEffects[id] = nil
    end
	
    local effect2 = arcEffects2[id];
    if effect2 ~= nil then
        Object.Delete(effect2)
        arcEffects2[id] = nil
    end
end

function DamageF(damage_amount)
    local posX = Get("Pos.x")
    local posY = Get("Pos.y")    
    for id, time in pairs(registerTiming) do
        -- using pcall to also validate for non-existing entities
        if pcall(ValidDamage, id, posX, posY) then
            DamageEntity(id, time, damage_amount)
        else                    
            UnregisterTarget(id)
        end                    
    end
end

function ValidDamage(id, posX, posY)
    if distanceSq(posX, posY, GetFrom(id, "Pos.x"), GetFrom(id, "Pos.y")) > SearchDistance ^ 2 then
        error()    
    end
end

function DamageEntity(id, time, damage_amount)    

    local newDamage = math.min(GetFrom(id, "Damage") + damage_amount, 1)
		
    SetOn(id, "Damage", newDamage)
    ElecArcEffectOnTarget(id)
		 
    if newDamage >= 1 then
        UnregisterTarget(id)
    end        
    
end

function ElecArcEffectOnTarget(id)
    effect = arcEffects[id];
    effect2 = arcEffects2[id];	
	
    local posX = GetFrom(id, "Pos.x");
    local posY = GetFrom(id, "Pos.y");
	
    local self_posX = Get("Pos.x")
    local self_posY = Get("Pos.y") 
	
	
	local quarter=0
	
	if self_posX>=posX then
		if self_posY>=posY then
			quarter=1
		else
			quarter=3
		end
	else
		if self_posY>=posY then
			quarter=2
		else
			quarter=4
		end	
	end
	
	
    if effect == nil then
        effect = Object.Spawn("ElectricArcEffect", posX, posY)
        arcEffects[id] = effect;
    end

    if effect2 == nil then
        effect2 = Object.Spawn("ElectricArcEffect2", self_posX, self_posY)
        arcEffects2[id] = effect2;
    end
    
    local subType = GetFrom(effect, "SubType") or 3
    subType = (subType + 1) % 4
    SetOn(effect, "SubType", subType);
	SetOn(effect, "Pos.x", posX)
    SetOn(effect, "Pos.y", posY)
	
	SetOn(effect2, "SubType", (quarter - 1) % 4)
	
	if quarter==1 then
		difX=-1
		difY=-1
	elseif quarter==2 then
		difX=1
		difY=-1	
	elseif quarter==3 then
		difX=-1
		difY=1	
	elseif quarter==4 then
		difX=1
		difY=1	
	end
	SetOn(effect2, "Pos.x", self_posX+difX)
    SetOn(effect2, "Pos.y", self_posY+difY)		
end







function distanceSq(x1,y1,x2,y2) return ((x2 - x1) ^ 2) + ((y2 - y1) ^ 2) end

function Set(name, value)
    Object.SetProperty(name, value);
end

function Get(name)
    return Object.GetProperty(name);
end

function GetN(name)
    return tonumber(Object.GetProperty(name));
end

function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end

function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
